/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * TODO documentation
 * @author rlogiacco
 */
public abstract class BusinessObject implements DataTransferObject {

	private final static long serialVersionUID = 8960870409825593855L;

	/**
	 * Allows for business operations logging.
	 */
	protected final transient Log logger = LogFactory.getLog(this.getClass());

	/**
	 * This number stores the object version and is used for optimistical
	 * locking.
	 */
	private long version;
	
	/**
	 * Returns the object version.
	 * This property ensures optimistical locking support to every subclass.
	 * 
	 * @return returns the version.
	 * @hibernate.version
	 */
	public long getVersion() {
		return version;
	}

	/**
	 * Sets the object version.
	 * This property ensures optimistical locking support to every subclass.
	 * 
	 * @param version the version to set.
	 */
	public void setVersion(long version) {
		this.version = version;
	}
}