/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web.bean;

import java.lang.reflect.Array;
import java.util.List;
import java.util.Locale;

/**
 * TODO documentation
 * 
 * @author rlogiacco
 */
public class StringArrayConverter extends ArrayConverter {

	/**
	 * @see net.smartlab.web.bean.Converter#convert(java.lang.Class,
	 *      java.lang.Object, java.util.Locale)
	 */
	public Object convert(Class type, Object value, Locale locale) throws ConversionException {
		// Deal with the no-conversion-needed case
		if (model.getClass() == value.getClass()) {
			return (value);
		}

		if (value.getClass().isArray()) {
			String[] results = new String[Array.getLength(value)];
			for (int i = 0; i < results.length; i++) {
				results[i] = Array.get(value, i).toString();
			}
			return results;
		}

		// Parse the input value as a String into elements
		// and convert to the appropriate type
		try {
			List list = parseElements(value.toString());
			String results[] = new String[list.size()];
			for (int i = 0; i < results.length; i++) {
				results[i] = (String)list.get(i);
			}
			return (results);
		} catch (Exception e) {
			throw new ConversionException(value.toString(), e);
		}
	}
}